<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
define('CPOBACKEND', true); 
require_once('../_include/common.inc.php');

$notimeout = true;
include(CPO_BASEDIR.'_include/header.php');

printPageHeader(
    __('Login'),
    __('Please log in using your username and password. If you don\'t remember your password, please use the \'reset password\' function on the left.'),
    'login-login.html#login-login'
);

switch ($_GET['action']) {
case 'csrf':
    $message[] = __('Security check failed. Please try again.');
    break;
case 'failed':
    $message[] = __('Login failed. Please check your username and password and try again.');
    break;
case 'timeout':
    $message[] = __('Session timed out. Please enter again using your username and password.');
    break;
case 'logout':
    $message[] = __('You were logged out. Please close the browser window to avoid people going back your page history.');
    break;
}
if (license($cpoSystem['lkey'])==4) {
    $message[] = sprintf(__('Please note that your test license is expired. To extend your test frame or to obtain an official license, please contact %s.'), 
        '<a href="'._htmlspecialchars($CPO['producerlink']).'" target="_blank">'._htmlspecialchars($CPO['producer']).'</a>');
}
include(CPO_BASEDIR.'_include/message.php');
?>

<form method="post" style="margin-top: 1em;" action="<?php print(_htmlspecialchars(BASE_REL.'_admin/index.php')); ?>" name="login" target="_top">
<table class="colored" style="width: 100%"><thead>
    <tr><th colspan="2"><span><?php print(___('Login')); ?></span></th></tr>
</thead><tbody>
    <?php $antiCSRF->printInput('login'); ?>
    <input type="hidden" name="rubric" value="<?php print(_htmlspecialchars($_REQUEST['rubric'])); ?>">
    <tr>
        <td class="leftrow"><?php print(___('Project:')); ?></td>
        <td class="rightrow">
            <?php print(_htmlspecialchars($cpoSystem['project'])); ?>
        </td>
    </tr><tr>
        <td class="leftrow"><?php print(___('License:')); ?></td>
        <td class="rightrow">
            <?php
            switch (license($cpoSystem['lkey'])) {
            case 1:
                printf(___('commercial license for %s'), $cpoSystem['owner']);
                break;
            case 2:
                printf(___('non commercial license for %s'), $cpoSystem['owner']);
                break;
            case 3: 
                printf(___('test license for %s'), $cpoSystem['owner']);
                break;
            case 4:
                printf('<span class="warn">'.___('expired test license for %s').'</span>', $cpoSystem['owner']);
                break;
            case 5:
                printf(___('school license for %s'), $cpoSystem['owner']);
                break;
            case false:
                echo ___('unregistered version');
                break;
            default:
                printf(___('unknown license type for %s'), $cpoSystem['owner']);
            }
            ?>
        </td>
    </tr><tr>
        <td class="leftrow"><?php print(___('Username:')); ?></td>
        <td class="rightrow">
            <input type="text" class="text" name="form_userlogin" size="16">
            <?php print(help('login-login.html#login-login-username')); ?>
        </td>
    </tr><tr>
        <td><?php print(___('Password:')); ?></td>
        <td>
            <input type="password" class="text" name="form_passwort" size="16">
            <?php print(help('login-login.html#login-login-password')); ?>
        </td>
    </tr><tr>
        <td>&nbsp;</td>
        <td> 
            <input type="submit" class="button" value="<?php print(___('log in')); ?>">
        </td>
    </tr>
</tbody></table>
</form>
<script type="text/javascript">document.login.form_userlogin.focus();</script>

<?php include(CPO_BASEDIR.'_include/footer.php');