<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/checkaccess.inc.php');

require(CPO_BASEDIR.'_include/check.php');

$now = date('Y-m-d H:i');
if (isset($_REQUEST['preview'])) {
    $now = date('Y-m-d H:i:s', strtotime($_REQUEST['preview']));
}

$views = array('frameset');

$actions = array();
if (isset($_REQUEST['action'])) is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);

while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'preview_selector':
        $views = array('selector');
        break;
    case 'preview_update':
        $now = date('Y-m-d H:i:s', strtotime(sprintf('%d-%d-%d %d:%d',
            $_POST['pub_date_year'],
            $_POST['pub_date_month'],
            $_POST['pub_date_day'],
            $_POST['pub_date_hour'],
            $_POST['pub_date_min']
        )));
        break;
    }
}

while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'selector':
        $_POST['pub_date_day']   = date('d', strtotime($now));
        $_POST['pub_date_month'] = date('m', strtotime($now));
        $_POST['pub_date_year']  = date('Y', strtotime($now));
        $_POST['pub_date_hour']  = date('H', strtotime($now));
        $_POST['pub_date_min']   = date('i', strtotime($now));
        ?>
        <html>
        <head>
            <link rel="stylesheet" type="text/css" href="<?php echo SKIN_URL.'style_cpo.css.php'; ?>">
        </head>
        <body id="previewSelectorBody">
        <script type="text/javascript">
        function setdate(field, values)
        {
            day=''; month=''; year=''; hour=''; min=''
            eval(values);
            if (year>=2036) { day=''; month=''; year=''; hour=''; min=''; }

            eval('window.document.preview_form.'+field+'_day.value = "'+day+'";');
            eval('window.document.preview_form.'+field+'_month.value = "'+month+'";');
            eval('window.document.preview_form.'+field+'_year.value = "'+year+'";');
            eval('window.document.preview_form.'+field+'_hour.value = "'+hour+'";');
            eval('window.document.preview_form.'+field+'_min.value = "'+min+'";');
        }
        </script>

        <?php
        printf('<form method="post" action="%s" name="preview_form" target="_top" style="margin: 0.5em;">', _htmlspecialchars($_SERVER['PHP_SELF']));
        print('<input type="hidden" name="action[]" value="preview_update" />');
        print(___('Time of preview:').' <select name="pubquick" size="1" onChange="setdate(\'pub_date\', this.value); this.selectedIndex=0;">');
        print('<option value="" selected>'.___('at this time').' ---&gt;</option>'); 
        $dates = array(
            __('now')=>strtotime('now'),
            __('tomorrow')=>strtotime('tomorrow 00:00'),
            __('in 2 days')=>strtotime('2 days 00:00'),
            __('in 3 days')=>strtotime('3 days 00:00'),
            __('in 5 days')=>strtotime('5 days 00:00'),
            __('in one week ')=>strtotime('7 days 00:00'),
            __('in 14 days')=>strtotime('14 days 00:00')
        );
        foreach ($dates as $k=>$v) {
            printf('<option value="day=%d; month=%d; year=%d; hour=%d; min=%d;">%s</option>',
                date('d', $v), date('m', $v), date('Y', $v),
                date('H', $v), date('i', $v),
                _htmlspecialchars($k)
            );
        }
        ?>
        </select> &nbsp;
        <input 
            value="<?php echo $_POST['pub_date_day']; ?>" name="pub_date_day"     type="text" size="2" maxlength="2">.<input 
            value="<?php echo $_POST['pub_date_month']; ?>" name="pub_date_month" type="text" size="2" maxlength="2">.<input 
            value="<?php echo $_POST['pub_date_year']; ?>" name="pub_date_year"   type="text" size="4" maxlength="4">&nbsp;&nbsp;<input 
            value="<?php echo $_POST['pub_date_hour']; ?>" name="pub_date_hour"   type="text" size="2" maxlength="2">:<input 
            value="<?php echo $_POST['pub_date_min']; ?>" name="pub_date_min"     type="text" size="2" maxlength="2">
        <?php
        printf('<input type="submit" name="button" value="%s" />', 
            ___('preview rubric')
        );
        print('</form>');
        print('</body></html>');
        break;

    case 'frameset': 
        print('<html><head><title>'.___('Preview').'</title>');
        echo '<link rel="stylesheet" type="text/css" href="' . SKIN_URL . 'style_cpo.css.php" />';
        echo '</head>';
        print('<frameset rows="40,*">');
        printf('<frame src="%s?action[]=preview_selector&amp;preview=%s" name="date" scrolling="no" noresize frameborder="0" id="previewSelector">',
            _htmlspecialchars($_SERVER['PHP_SELF']),
            urlencode($now)
        );
        printf('<frame src="%s&amp;preview=%s" name="rubric" noresize frameborder="0" id="previewContent">',
            _htmlspecialchars(BASE_REL.$_SESSION['SID_rubric_directory'].'/index.php?rubric='.$_SESSION['SID_rubric_id']),
            _htmlspecialchars($now)
        );
        print('</frameset>');
        print('</html>');
    }
}