<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
define('CPO', true);
require_once('../_include/checkaccess.inc.php');

require(CPO_BASEDIR.'_include/check.php');

$db = new DB;

if (!isset($_SESSION['SID_navigation_opened'])) $_SESSION['SID_navigation_opened'] = array();

$views = array('list');

$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) ? $actions = $_REQUEST['action'] : $actions = array($_REQUEST['action']);
while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'close': // {{{
        if (isset($_SESSION['SID_navigation_opened'][$_GET['id']])) unset($_SESSION['SID_navigation_opened'][$_GET['id']]);
        break; // }}}
    case 'open': // {{{
        $_SESSION['SID_navigation_opened'][$_GET['id']] = true;
        break; // }}}
    case 'rubrics_delete': // {{{
        $db = new DB;
        $db->query('SELECT name FROM '.CPO_RUBRIC.' '
                  .'WHERE id='.(int)$_GET['id']);
        $db->next_record() ? $_rubric = $db->v('name') :  $_rubric = '';
        $name = $db->v('name');

        $views = array('reallydelete');
        break;
    // }}}
    case 'rubrics_delete_really': // {{{
        if ($_SESSION['SID_user']['admin']<ROLE_SUPERUSER) break;

        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('delete rubric', 'CSRF check failed.');

            $db = new DB;
            $db->query('SELECT name FROM '.CPO_RUBRIC.' '
                      .'WHERE id='.(int)$_POST['id']);
            $db->next_record() ? $_rubric = $db->v('name') :  $_rubric = '';
            $name = $db->v('name');

            $views = array('reallydelete');
            break;
        }

        $db->query('SELECT name FROM '.CPO_RUBRIC.' '
                  .'WHERE id='.(int)$_POST['id']);
        $db->next_record() ? $_rubric = $db->v('name') :  $_rubric = '';

        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The rubric %s was not deleted.'), '<em>'._htmlspecialchars($_rubric).'</em>');
            break;
        }

        $query = array();
        $query[] = "UPDATE ".CPO_DATA." SET rubric_id = '-1' "
                  ."WHERE rubric_id='".$_POST['id']."'";
        $query[] = "UPDATE ".CPO_NAVTREE." SET rubric_id = '0' "
                  ."WHERE rubric_id='".$_POST['id']."'";
        $query[] = "DELETE FROM ".CPO_PERMISSION." "
                  ."WHERE rubric_id='".$_POST['id']."'";
        $query[] = "DELETE FROM ".CPO_RUBRIC." "
                  ."WHERE id='".$_POST['id']."'";
        $query[] = "DELETE FROM ".CPO_RUBRIC_PERMISSION." "
                  ."WHERE rubric_id='".$_POST['id']."'";
        // FIXME SNIPPETS, STATISTICS
        $query[] = "DELETE FROM ".CPO_TPL_ASSIGNMENT." "
                  ."WHERE rubric_id='".$_POST['id']."'";
        
        $q = "SELECT nr FROM ".CPO_NEWS." "
            ."WHERE rubric_id='".$_POST['id']."'";
        $db->query($q);
        while ($db->next_record()) {
            $query[] = "DELETE FROM ".CPO_CONTENT_FILES." "
                      ."WHERE article_id='".$db->v('nr')."'";
            $query[] = "DELETE FROM ".CPO_CONTENT_HTML." "
                      ."WHERE article_id='".$db->v('nr')."'";
            $query[] = "DELETE FROM ".CPO_CONTENT_IMAGES." "
                      ."WHERE article_id='".$db->v('nr')."'";
            $query[] = "DELETE FROM ".CPO_CONTENT_TEXT." "
                      ."WHERE article_id='".$db->v('nr')."'";
            $query[] = "DELETE FROM ".CPO_CONTENT_URLS." "
                      ."WHERE article_id='".$db->v('nr')."'";
        }
        $query[] = "DELETE FROM ".CPO_NEWS." "
                  ."WHERE rubric_id='".$_POST['id']."'";
                    
        foreach ($query as $k=>$v) $db->query($v);

        $message[] = sprintf(___('The rubric %s was successfully deleted.'), '<em>'._htmlspecialchars($_rubric).'</em>');
        logaction('delete rubric', $_rubric);
        break; // }}}
    case 'rubrics_create': // {{{
        $_REQUEST['id']            = 0;
        $_POST['directory']        = '';
        $_POST['name']             = '';
        $_POST['seclevel']         = 0;
        $_POST['source_rubric_id'] = 0;
        $_POST['cpoRubricSettings'] = $cpoRubricSettingsDefaults;
        if (in_array($cpoSystem['language'], $translator->findTranslations())) {
            $_POST['cpoRubricSettings']['language'] = $cpoSystem['language'];
        }
        $views = array('create');
        break; // }}}
    case 'rubrics_showsettings': // {{{
        $query = "SELECT directory, name, seclevel, source_rubric_id, settings "
                ."FROM ".CPO_RUBRIC." "
                ."WHERE id='".addslashes($_REQUEST['id'])."'";
        $db->query($query);

        // basic settings
        $_POST['directory']        = '';
        $_POST['name']             = '';
        $_POST['seclevel']         = 0;
        $_POST['source_rubric_id'] = 0;
        while($db->next_record()) { // will only loop once
            $_POST['directory']        = $db->v('directory');
            $_POST['name']             = $db->v('name');
            $_POST['seclevel']         = $db->v('seclevel');
            $_POST['source_rubric_id'] = $db->v('source_rubric_id');
            $_settings = $db->v('settings');
        }

        // individual extended settings
        if (is_string($_settings)) $t_cpoRubricSettings = unserialize($_settings);
        if (!is_array($t_cpoRubricSettings)) $t_cpoRubricSettings = array();
        foreach ($cpoRubricSettingsDefaults as $k=>$v) {
            if (isset($t_cpoRubricSettings[$k])) { 
                $_POST['cpoRubricSettings'][$k] = $t_cpoRubricSettings[$k];
                continue;
            }
            // use default setting as it was not stored in the DB yet
            $_POST['cpoRubricSettings'][$k] = $v;
        }


        // advanced settings
        if ($_POST['source_rubric_id']!=0) {
            // use different source for advanced settings?
            $query = "SELECT settings "
                    ."FROM ".CPO_RUBRIC." "
                    ."WHERE id='".addslashes($db->v('source_rubric_id'))."'";
            DEBUG(1, 'Fetching settings from other rubric... <br /><br />'. $query, __FILE__, __LINE__);
            $db->query($query);
            $db->next_record();
            $_settings = $db->v('settings');
        }

        if (is_string($_settings)) $t_cpoRubricSettings = unserialize($_settings);
        if (!is_array($t_cpoRubricSettings)) $t_cpoRubricSettings = array();
        foreach ($cpoRubricSettingsDefaults as $k=>$v) {
            if ($k=='title') continue;
            if (isset($t_cpoRubricSettings[$k])) { 
                $_POST['cpoRubricSettings'][$k] = $t_cpoRubricSettings[$k];
                continue;
            }
            // use default setting as it was not stored in the DB yet
            $_POST['cpoRubricSettings'][$k] = $v;
        }

        // activate templates that are active 
        $_POST['templates'] = array();
        $query = "SELECT templates_id "
                ."FROM ".CPO_TPL_ASSIGNMENT." "
                ."WHERE rubric_id='".addslashes($_REQUEST['id'])."' ";
        DEBUG(1, 'Load existing article-template assignments.'.$query, __FILE__, __LINE__);   
        $db->query($query);
        while($db->next_record()) $_POST['templates'][] = $db->v('templates_id');

        // add standard template if it was not selected with the others...
        if (!in_array($_POST['cpoRubricSettings']['standard_template'], $_POST['templates']))
            $_POST['templates'][] = $_POST['cpoRubricSettings']['standard_template'];

        // fetch usergroups that have the right to access this rubric
        $_POST['groupaccess'] = array();
        $query = "SELECT usergroups_id "
                ."FROM ".CPO_RUBRIC_PERMISSION." "
                ."WHERE rubric_id='".addslashes($_REQUEST['id'])."' ";
        DEBUG(1, $query, __FILE__, __LINE__);   
        $db->query($query);
        while($db->next_record()) $_POST['groupaccess'][] = $db->v('usergroups_id');

        $views = array('settings');
        break; // }}}
    case 'rubrics_savesettings': // {{{
    case 'rubrics_createnew':
        $views = array('settings');

        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            if ($nextaction=='rubrics_savesettings') logaction('edit rubric settings', 'CSRF check failed.');
            else                                     logaction('create rubric', 'CSRF check failed.');
            break;
        }

        if (!empty($_POST['backtolist'])) $views = array('list');

        if (!isset($_POST['templates']) || !is_array($_POST['templates'])) $_POST['templates'] = array();

        $saveSettings = true;
        if (empty($_POST['name'])) {
            $message[] = __('Please give this rubric a name.');
            $views = array('settings');
            if ($nextaction=='rubrics_createnew') $views = array('create');
            $saveSettings = false;
        }

        // add element if requested
        if (isset($_POST['rubrics_addsorting'])) {
            $_POST['cpoRubricSettings']['newSorting'][] = '';
            $message[] = __('Added sorting element.');
            $saveSettings = false;
        }

        // delete element if requested
        foreach ($_POST as $k => $v) {
            if (substr($k, 0, 19)!='rubrics_delsorting_') continue;
            $message[] = __('Deleted sorting element.');
            unset($_POST['cpoRubricSettings']['newSorting'][substr($k, 19)]);
            $saveSettings = false;
            break; // break two levels!
        }

        if (!is_array($_POST['cpoRubricSettings']['newSorting']))
            $_POST['cpoRubricSettings']['newSorting'] = $cpoRubricSettingsDefaults['newSorting'];

        // check if sorting field is used more than once
        $fields = array();
        $comma = '';
        $_POST['cpoRubricSettings']['sorting'] = '';
        foreach ($_POST['cpoRubricSettings']['newSorting'] as $v) {
            $field = explode(' ', $v);
            $field = $field[0];
            if (isset($fields[$field])) {
                $message[] = __('Please make sure that each sorting element is only used once.');
                $saveSettings = false;
                break;
            }
            $fields[$field] = true;
            $_POST['cpoRubricSettings']['sorting'] .= $comma . $v;
            $comma = ', ';
        }

        if (!$saveSettings) {
            $views = array('settings');
            if ($nextaction=='rubrics_createnew') $views = array('create');
            break;
        }

        if (!isset($_POST['cpoRubricSettings']) || !is_array($_POST['cpoRubricSettings'])) 
            $_POST['cpoRubricSettings'] = array();
        
        foreach ($cpoRubricSettingsDefaults as $k=>$v) {
            if (!isset($_POST['cpoRubricSettings'][$k])) { // set default value if necessary
                $_POST['cpoRubricSettings'][$k] = $cpoRubricSettingsDefaults[$k];
                continue;
            }
            if (is_bool($v)) { // cast to bool if it is in the defaults
                $_POST['cpoRubricSettings'][$k] = (bool)$_POST['cpoRubricSettings'][$k];
            }
        }

        $query = "REPLACE ".CPO_RUBRIC." "
                ."(id, directory, name, seclevel, source_rubric_id, settings ) VALUES ("
                ."'".addslashes($_REQUEST['id'])."', "
                ."'".addslashes($_POST['directory'])."', "
                ."'".addslashes($_POST['name'])."', "
                ."'".addslashes($_POST['seclevel'])."', "
                ."'".addslashes($_POST['source_rubric_id'])."', "
                ."'".addslashes(serialize($_POST['cpoRubricSettings']))."' "
                .")"; 
        DEBUG(1, 'storing settings in database.<br /><br />'.$query, __FILE__, __LINE__);
        $db->query($query);

        if (empty($_REQUEST['id'])) { // a new rubric was created
            $query = "SELECT last_insert_id()";
            $db->query($query);
            $db->next_record();
            $_REQUEST['id'] = $db->v('last_insert_id()');

            // allow the creating user to access the rubric
            $sql = "INSERT INTO ".CPO_PERMISSION." "
                  ."(rubric_id, user_id, stufe1, stufe2, stufe3, stufe4) "
                  ."VALUES ( "
                  ."'".$_REQUEST['id']."', " // rubric_id
                  ."'".$_SESSION['SID_user']['id']."', " // user_id
                  ."'1', " // stufe1 
                  ."'1', " // stufe2
                  ."'1', " // stufe3
                  ."'1' )"; // stufe4
            $db->query($sql);
        }

        // update template assignments
        $sql = "DELETE FROM ".CPO_TPL_ASSIGNMENT." "
             . "WHERE rubric_id='".$_REQUEST['id']."'";
        DEBUG(1, 'Deleting article-template assignments for this rubric.<br /><br />'.$sql, __FILE__, __LINE__);
        $db->query($sql);

        // if the standard_template is not selected with the other templates, do so...
        if (isset($_POST['cpoRubricSettings']['standard_template']) 
            && !in_array($_POST['cpoRubricSettings']['standard_template'], $_POST['templates'])) {
            $_POST['templates'][] = $_POST['cpoRubricSettings']['standard_template'];
        }

        foreach($_POST['templates'] as $k => $v) {
            $sql = "INSERT INTO ".CPO_TPL_ASSIGNMENT." "
                 . "(rubric_id, templates_id) VALUES ("
                 . "'".addslashes($_REQUEST['id'])."', "
                 . "'".addslashes($v)."') ";
            DEBUG(1, 'Inserting tpl assignement.<br /><br />'.$sql, __FILE__, __LINE__);
            $db->query($sql);
        }

        // update rubric rights
        $query = "DELETE FROM ".CPO_RUBRIC_PERMISSION." WHERE rubric_id='".addslashes($_REQUEST['id'])."'";
        DEBUG(2, $query, __FILE__, __LINE__);
        $db->query($query);

        if (!isset($_POST['groupaccess'])) $_POST['groupaccess'] = array();
        $db2 = new DB;
        foreach ($_POST['groupaccess'] as $k=>$v) {
            $query = "INSERT INTO ".CPO_RUBRIC_PERMISSION." (usergroups_id, rubric_id, c_time, changer) VALUES ("
                    ."'".addslashes($v)."', "
                    ."'".addslashes($_REQUEST['id'])."', "
                    ."'".date('Y-m-d H:i:s')."', "
                    ."'".$_SESSION['SID_login']."')";
            DEBUG(2, $query, __FILE__, __LINE__);
            $db2->query($query);
        }

        $message[] = sprintf(___('Saved the rubric settings for rubric %s.'), '<em>'._htmlspecialchars($_POST['name']).'</em>');

        if ($nextaction=='rubrics_savesettings') logaction('edit rubric settings', $_POST['name']);
        else                                     logaction('create rubric', $_POST['name']);

        break; // }}}
    case 'rubrics_addsorting':
        break;
    }
}

while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'list': // {{{
        require(CPO_BASEDIR.'_views/rubrics_list.inc.php');
        break; // }}}
    case 'settings': // {{{
    case 'create': 
        // fill rubric settings with defaults or cast values to boolean if necessary
        if (!isset($_POST['cpoRubricSettings']) || !is_array($_POST['cpoRubricSettings'])) $_POST['cpoRubricSettings'] = array();
        foreach ($cpoRubricSettingsDefaults as $k=>$v) {
            if (!isset($_POST['cpoRubricSettings'][$k])) { // set default value if necessary
                $_POST['cpoRubricSettings'][$k] = $cpoRubricSettingsDefaults[$k];
                continue;
            }
            if (is_bool($v)) { // cast to bool if it is in the defaults
                $_POST['cpoRubricSettings'][$k] = (bool)$_POST['cpoRubricSettings'][$k];
            }
        }

        require(CPO_BASEDIR.'_include/header.php');

        if ($_REQUEST['id']==0) {
            printPageHeader( 
                __('Create rubric'),
                __('In this view you can create a new rubric.'),
                'rubrics-createrubric.html#rubrics-createrubric'
            );
        } else {
            printPageHeader( 
                __('Edit rubric settings'),
                    sprintf(__('In this view you can edit the settings for rubric %s.'), 
                    '<em>'._htmlspecialchars($_POST['name']).'</em>'),
                'rubrics-listrubrics.html#rubrics-listrubrics-rubricsettings'
            );
        }
        include(CPO_BASEDIR.'_include/message.php');
        ?>
        <form method="post" action="<?php echo $_SERVER['PHP_SELF']; ?>">
        <input type="hidden" name="id" value="<?php echo _htmlspecialchars($_REQUEST['id']); ?>">
        <?php
        if ($nextview=='settings') $antiCSRF->printInput('rubrics_savesettings');
        else                       $antiCSRF->printInput('rubrics_createnew');
        ?>
        <table class="colored" style="width: 100%"><thead><tr>
            <th colspan="2"><span><?php echo ___('Basic rubric settings'); ?></span></th>
        </tr></thead><tbody>
            <?php if ($_REQUEST['id']!=0) { ?>
                <tr>
                    <td class="leftrow"><?php echo ___('Rubric id:'); ?></td>
                    <td class="rightrow">
                        <?php echo _htmlspecialchars($_REQUEST['id']).help('rubrics-listrubrics.html#rubrics-listrubrics-basesettings-rubricid'); ?>
                    </td>
                </tr>
                <tr>
                    <td class="leftrow"><?php echo ___('Include rubrics:'); ?></td>
                    <td class="rightrow">
                        <?php 
                        if ($_POST['seclevel']==SECLEVEL_CLOSED) {
                            echo ___('You can not include a closed rubric.');
                        }
                        ?>
                    </td>
                </tr>
                <?php 
                if ($_POST['seclevel']!=SECLEVEL_CLOSED) {
                    echo '<tr class="same">';
                    echo '<td class="leftrow">';
                    echo ___('PHP-variant:');
                    echo '</td><td class="rightrow">';
                    echo _htmlspecialchars('<?php include(\'');
                    echo BASE_ABS._htmlspecialchars($_POST['directory']).'/index_php.php?rubric='.urlencode($_POST['name']);
                    echo _htmlspecialchars('\'); ?>');
                    echo help('rubrics-listrubrics.html#rubrics-listrubrics-basesettings-includerubrics-php');
                    echo '</td></tr><tr class="same">';
                    echo '<td class="leftrow">';
                    echo ___('Javascript-variant:');
                    echo '</td><td class="rightrow">';
                    echo _htmlspecialchars('<script language="JavaScript" type="text/javascript" src="');
                    echo BASE_ABS._htmlspecialchars($_POST['directory']).'/index_js.php?rubric='.urlencode($_POST['name']);
                    echo _htmlspecialchars('"></script>');
                    echo help('rubrics-listrubrics.html#rubrics-listrubrics-basesettings-includerubrics-javascript');
                    echo '</td></tr>';
                }
            } ?>
        <tr>
            <td class="leftrow"><?php echo ___('Rubric name:'); ?></td>
            <td class="rightrow">
                <input type="text" name="name" value="<?php echo _htmlspecialchars($_POST['name']); ?>" maxlength="255" class="text inputwidth">
                <?php echo help('rubrics-listrubrics.html#rubrics-listrubrics-basesettings-rubricname'); ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Rubric directory:'); ?></td>
            <td class="rightrow">
                <select name="directory">
                    <?php
                    $rubricdirs = array();
                    if ($handle = opendir(CPO_BASEDIR)) {
                        while (($file = readdir($handle)) !== false) {
                            if (!is_dir(CPO_BASEDIR.$file) 
                                || !is_readable(CPO_BASEDIR.$file) 
                                || !file_exists(CPO_BASEDIR.$file.'/rubric.cpo')) continue;
                            $rubricdirs[] = $file;
                        }
                        closedir($handle);
                    }
                    sort($rubricdirs);
                    foreach ($rubricdirs as $v) {
                        printf('<option value="%1$s" %2$s>%1$s</option>', 
                            _htmlspecialchars($v),
                            $_POST['directory'] == $v ? 'selected' : ''
                        );
                    }
                    ?>
                </select> 
                <?php echo help('rubrics-listrubrics.html#rubrics-listrubrics-basesettings-rubricdirectory'); ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Rubric type:'); ?></td>
            <td class="rightrow">
                <select name="seclevel">
                    <?php 
                    echo '<option value="'.SECLEVEL_PUBLIC.'" '.($_POST['seclevel']==SECLEVEL_PUBLIC ? 'selected' : '').'>'
                        .___('public rubric').'</option>';
                    echo '<option value="'.SECLEVEL_PERSONALIZED.'" '.($_POST['seclevel']==SECLEVEL_PERSONALIZED ? 'selected' : '').'>'
                        .___('personalized rubric').'</option>';
                    echo '<option value="'.SECLEVEL_CLOSED.'" '.($_POST['seclevel']==SECLEVEL_CLOSED ? 'selected' : '').'>'
                        .___('closed rubric').'</option>';
                    ?>
                </select>
                <?php echo help('rubrics-listrubrics.html#rubrics-listrubrics-basesettings-rubrictype'); ?>
            </td>
        </tr>
        <?php 
        if ($_POST['seclevel']==SECLEVEL_CLOSED) { ?>
            <tr>
                <td class="leftrow"><?php echo ___('Group access:'); ?></td>
                <td class="rightrow">
                        <?php 
                        // fetch all usergroups 
                        $query = "SELECT id, usergroup "
                                ."FROM ".CPO_USERGROUPS." "
                                ."ORDER BY usergroup";
                        DEBUG(1, $query, __FILE__, __LINE__);   
                        $db->query($query);
                        $grouprights = array();

                        $nogroups = '<img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> '.__('There were no usergroups created yet.');
                        $help = help('rubrics-listrubrics.html#rubrics-listrubrics-basesettings-groupaccess');

                        if (!isset($_POST['groupaccess'])) $_POST['groupaccess'] = array();
                        while ($db->next_record()) {
                            $nogroups = '';
                            printf('<input type="checkbox" class="checkbox" name="groupaccess[]" value="%d" id="groupaccess_'.(int)$db->v('id').'" %s><label for="groupaccess_'.(int)$db->v('id').'"> %s</label>',
                                _htmlspecialchars($db->v('id')),
                                in_array($db->v('id'), $_POST['groupaccess']) ? 'checked' : '',
                                _htmlspecialchars($db->v('usergroup'))
                            );
                            echo $help; 
                            $help = '';
                            echo '<br />';
                        }
                        print($nogroups);
                        ?>    
                </td>
            <?php 
        } // if ($_POST['seclevel']==SECLEVEL_CLOSED) { 
        ?>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Disable rubric:'); ?></td>
            <td class="rightrow">
                <?php 
                echo '<input name="cpoRubricSettings[disableRubric]" class="checkbox" type="checkbox" value="1" id="disableRubric" ';
                echo ($_POST['cpoRubricSettings']['disableRubric'] ? 'checked' : '').'> ';
                echo '<label for="disableRubric">';
                echo ___('disable rubric and show the following text instead:');
                echo '</label>';
                echo help('rubrics-listrubrics.html#rubrics-listrubrics-basesettings-deactivaterubric'); 
                echo '<br />';
                echo '<input name="cpoRubricSettings[disableRubricText]" type="text" '
                    .'value="'._htmlspecialchars($_POST['cpoRubricSettings']['disableRubricText']).'" class="text inputwidth">';
                ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Rubric title:'); ?></td>
            <td class="rightrow">
                <input name="cpoRubricSettings[title]" class="text inputwidth" type="text" value="<?php echo _htmlspecialchars($_POST['cpoRubricSettings']['title']); ?>">
                <?php echo help('rubrics-listrubrics.html#rubrics-listrubrics-basesettings-rubricheader'); ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Meta description:'); ?></td>
            <td class="rightrow">
                <input type="text" name="cpoRubricSettings[metaDescription]" value="<?php echo _htmlspecialchars($_POST['cpoRubricSettings']['metaDescription']); ?>" maxlength="255" class="text inputwidth">
                <?php echo help(''); // FIXME41 ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Meta keywords:'); ?></td>
            <td class="rightrow">
                <input type="text" name="cpoRubricSettings[metaKeywords]" value="<?php echo _htmlspecialchars($_POST['cpoRubricSettings']['metaKeywords']); ?>" maxlength="255" class="text inputwidth">
                <?php echo help(''); // FIXME41 ?>
            </td>
        </tr><tr>
            <td class="leftrow">&nbsp;</td>
            <td class="rightrow">
                <input type="submit" class="button" value="<?php echo ___('save'); ?>">
                <input type="submit" class="button" name="backtolist" value="<?php echo ___('save and go back to rubric list'); ?>">
            </td>
        <?php

        print('</tr></tbody></table>');
        array_unshift($views, 'extendedsettings');
        break; // }}}
    case 'extendedsettings': // {{{
        ?>
        <table class="colored" style="width: 100%"><thead><tr>
            <th colspan="2"><span><?php echo ___('Extended rubric settings source'); ?></span></th>
        </tr></thead><tbody>
        <tr>
            <?php
            $query = "SELECT id, name FROM ".CPO_RUBRIC." "
                    ."WHERE source_rubric_id='".addslashes($_REQUEST['id'])."' "
                    ."AND source_rubric_id!=0 " // avoid conflict with creating a rubric and rubrics that use individual settings
                    ."ORDER BY name";
            DEBUG(1, 'Fetching rubrics that use this rubric as source.<br /><br />'.$query, __FILE__, __LINE__);   
            $db->query($query);
            if ($db->num_rows()>0) { 
                echo '<td class="leftrow">'.___('Rubrics using these settings:').'</td>';
                echo '<td class="rightrow">';
                $comma = '';
                while ($db->next_record()) {
                    printf($comma.'<a href="%s">%s</a></li>',  
                        _htmlspecialchars($_SERVER['PHP_SELF'].'?action=rubrics_showsettings&id='.$db->v('id')),
                        _htmlspecialchars($db->v('name'))
                    ); 
                    $comma = ', ';
                } 
                echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedrubricsettingssource');
                echo '</td>';
            } else { 
                echo '<td class="leftrow">'.___('Source:').'</td>';
                echo '<td class="rightrow">';

                $query = "SELECT id, name FROM ".CPO_RUBRIC." "
                        ."WHERE id!='".addslashes($_REQUEST['id'])."' "
                        ."AND source_rubric_id='0' "
                        ."ORDER BY name";
                DEBUG(1, 'Fetching rubrics that might be used as extended settings source.<br /><br />'.$query, __FILE__, __LINE__);   
                $db->query($query);

                echo '<select name="source_rubric_id">';
                printf('<option value="0" %s>'.___('individual settings').'</option>',
                    $_POST['source_rubric_id']==0 ? 'selected' : ''
                ); 
                while ($db->next_record()) {
                    printf('<option value="%d" %s>%s</option>',
                        _htmlspecialchars($db->v('id')),
                        $_POST['source_rubric_id']==$db->v('id') ? 'selected' : '',
                        _htmlspecialchars($db->v('name'))
                    ); 
                }
                echo '</select>';
                echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedrubricsettingssource'); 

                if ($_POST['source_rubric_id']!=0) { 
                    printf('<br /><a href="%s">%s</a>',  
                        _htmlspecialchars($_SERVER['PHP_SELF'].'?action=rubrics_showsettings&id='.$_POST['source_rubric_id']),
                        __('Edit settings for chosen rubric.')
                    ); 
                }
                echo '</td>';

                echo '</tr><tr>';
                echo '<td class="leftrow">&nbsp;</td>';
                echo '<td class="rightrow">';
                echo '<input type="submit" class="button" value="'.___('save').'">';
                echo '<input type="submit" class="button" name="backtolist" value="'.___('save and go back to rubric list').'">';
                echo '</td>';
            } 

            if ($_POST['source_rubric_id']==0) { 
                echo '</tr></tbody></table>';
                array_unshift($views, 'individualsettings');
                break;
            }
            echo '</tr></tbody></table>';
            echo '</form>';

            require(CPO_BASEDIR.'_include/footer.php');
            break; // }}}
    case 'individualsettings': // {{{
        if (!isset($_POST['templates']) || !is_array($_POST['templates'])) $_POST['templates'] = array();
        ?>
        <table class="colored" style="width: 100%"><thead><tr>
            <th colspan="2"><span><?php echo __('Extended rubric settings'); ?></span></th>
        </tr></thead><tbody>
        <tr>
            <td class="leftrow"><?php echo ___('Text if no article was found:'); ?></td>
            <td class="rightrow">
                <input name="cpoRubricSettings[noArticlesFound]" type="text" value="<?php echo _htmlspecialchars($_POST['cpoRubricSettings']['noArticlesFound']); ?>" class="text inputwidth">
                <?php echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedsettings-noarticlefound'); ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('No. of articles on rubric-page:'); ?></td>
            <td class="rightrow">
                <input name="cpoRubricSettings[noOfArticles]" type="text" value="<?php echo $_POST['cpoRubricSettings']['noOfArticles']; ?>" class="text inputwidth">
                <?php echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedsettings-noofarticles'); ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Sorting method:'); ?></td>
            <td class="rightrow">
                <?php
$fields = array(
    'titel ASC'          => 'Title ascending', 
    'titel DESC'         => 'Title descending', 
    'datum ASC'          => 'Date ascending',
    'datum DESC'         => 'Date descending',
    'verfallsdatum ASC'  => 'Expiration date ascending',
    'verfallsdatum DESC' => 'Expiration date descending',
    'pub_datum ASC'      => 'Publication date ascending',
    'pub_datum DESC'     => 'Publication date descending',
    'idx ASC'            => 'Index ascending',
    'idx DESC'           => 'Index descending',
    'sort_id DESC'       => 'Manual',
);

foreach ($_POST['cpoRubricSettings']['newSorting'] as $k => $v) {
    echo '<select name="cpoRubricSettings[newSorting][' . $k . ']">';
    foreach ($fields as $field => $caption) {
        echo '<option value="' . $field . '" ' . 
            ($_POST['cpoRubricSettings']['newSorting'][$k]==$field ? 'selected' : '') . 
            '>';
        echo ___($caption) . '</option>';
    }
    echo '</select>';
    if ($k>0) {
        echo '<input type="submit" name="rubrics_delsorting_' . $k . '" value="' . ___('delete') . '" />';
    }
    echo '<br />';
}
echo '<input type="submit" name="rubrics_addsorting" value="' . ___('add') . '" />';
     ?>
                <?php echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedsettings-articlesorting'); ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Allow editing of fields:'); ?></td>
            <td class="rightrow">
                <?php 
                print('<div style="float: left; margin-right: 1em; width: 30%;">');
                echo '<input name="cpoRubricSettings[edit_index]" class="checkbox" type="checkbox" value="1" id="edit_index" ';
                echo ($_POST['cpoRubricSettings']['edit_index'] ? 'checked' : '').'> ';
                echo '<label for="edit_index">';
                echo ___('Index');
                echo '</label>';
                echo '<br />';

                echo '<input name="cpoRubricSettings[edit_author]" class="checkbox" type="checkbox" value="1" id="edit_author" ';
                echo ($_POST['cpoRubricSettings']['edit_author'] ? 'checked' : '').'> ';
                echo '<label for="edit_author">';
                echo ___('Author'); 
                echo '</label>';
                echo '<br />';
                print('</div>');

                print('<div style="float: left; margin-right: 1em;">');
                echo '<input name="cpoRubricSettings[edit_initial]" class="checkbox" type="checkbox" value="1" id="edit_initial" ';
                echo ($_POST['cpoRubricSettings']['edit_initial'] ? 'checked' : '').'> ';
                echo '<label for="edit_initial">';
                echo ___('Initials'); 
                echo '</label>';
                echo '<br />';

                echo '<input name="cpoRubricSettings[edit_email]" class="checkbox" type="checkbox" value="1" id="edit_email" ';
                echo ($_POST['cpoRubricSettings']['edit_email'] ? 'checked' : '').'> ';
                echo '<label for="edit_email">';
                echo ___('E-mail'); 
                echo '</label>';
                print('</div>');

                echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedsettings-allowediting'); 
                ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Page-templates:'); ?></td>
            <td class="rightrow">
                <?php
                $query = 'SELECT id, name FROM '.CPO_PAGETEMPLATES.' '
                        .'ORDER BY name';
                $db->query($query);
                $_pagetemplates = array();
                while ($db->next_record()) {
                    $_pagetemplates[$db->v('id')] = $db->v('name');
                }

                echo ___('Rubric page').': ';
                echo '<select name="cpoRubricSettings[pagetemplate_index]" size="1">';
                echo '<option value="0"'
                    .($_POST['cpoRubricSettings']['pagetemplate_index']==0 ? ' selected' : '')
                    .'>'.___('Use header and footer files').'</option>';
                foreach ($_pagetemplates as $k=>$v) {
                    echo '<option value="'._htmlspecialchars($k).'"'
                        .($_POST['cpoRubricSettings']['pagetemplate_index']==$k ? ' selected' : '')
                        .'>'._htmlspecialchars($v).'</option>';
                }
                echo '</select><br />';

                echo ___('Article page').': ';
                echo '<select name="cpoRubricSettings[pagetemplate_detail]" size="1">';
                echo '<option value="0"'
                    .($_POST['cpoRubricSettings']['pagetemplate_detail']==0 ? ' selected' : '')
                    .'>'.___('Use header and footer files').'</option>';
                foreach ($_pagetemplates as $k=>$v) {
                    echo '<option value="'._htmlspecialchars($k).'"'
                        .($_POST['cpoRubricSettings']['pagetemplate_detail']==$k ? ' selected' : '')
                        .'>'._htmlspecialchars($v).'</option>';
                }
                echo '</select><br />';
                ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Article-templates:'); ?></td>
            <td class="rightrow">
                <?php
                $query = "SELECT id, name FROM ".CPO_TEMPLATES." "
                        ."ORDER BY name";
                $db->query($query);

                $tablestart = '<table><thead><tr><td>'.___('standard').'</td><td>'.___('allowed').'</td><td>'.___('Article-template name').'</td><td>'.help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedsettings-articletemplates').'</td></tr></thead><tbody>';
                $tableend = '';
                while ($db->next_record()) {
                    // choose first as standard
                    if (empty($_POST['cpoRubricSettings']['standard_template'])) $_POST['cpoRubricSettings']['standard_template'] = (int)$db->v('id');

                    echo $tablestart; 
                    $tablestart = '';
                    $tableend = '</tbody></table>';
                    echo '<tr>';
                    echo '<td style="text-align: center;">';
                    echo '<input class="radio" type="radio" name="cpoRubricSettings[standard_template]" ';
                    echo 'value="'.(int)$db->v('id').'"';
                    echo ($_POST['cpoRubricSettings']['standard_template']==$db->v('id') ? ' checked' : '').'>';
                    echo '</td>';

                    echo '<td style="text-align: center;">';
                    echo '<input class="checkbox" type="checkbox" name="templates[]" ';
                    echo 'value="'.(int)$db->v('id').'" id="templates_'.(int)$db->v('id').'"';
                    echo (in_array($db->v('id'), $_POST['templates']) ? ' checked' : '').' />';
                    echo '</td>';


                    echo '<td>';
                    echo '<label for="templates_'.(int)$db->v('id').'">'._htmlspecialchars($db->v('name')).'</label>';
                    echo '</td>';

                    echo '<td>&nbsp;</td>';
                    echo '</tr>';
                }
                echo $tableend;
                
                ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Rubric language:'); ?></td>
            <td class="rightrow">
                <?php
                echo '<select name="cpoRubricSettings[language]" size="1">';
                $d = $translator->findTranslations();

                foreach ($d as $v) {
                    echo '<option value="'.$v.'"';
                    if ($_POST['cpoRubricSettings']['language']==$v) echo " selected";
                    echo ">"._htmlspecialchars($v)."</option>\n";
                }
                echo '</select>';
                echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedsettings-rubriclanguage');
                ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Date format:'); ?></td>
            <td class="rightrow">
                <input name="cpoRubricSettings[date_format]" type="text" value="<?php echo $_POST['cpoRubricSettings']['date_format']; ?>" class="text inputwidth">
                <?php 
                echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedsettings-dateformat'); 
                printf(
                    '<br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> '
                    .__('If this field is empty, it will use the date format of the system settings (%s).'), 
                    _htmlspecialchars($cpoSystem['date_format'])
                ); ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Article divider:'); ?></td>
            <td class="rightrow">
                <textarea class="textarea inputwidth" name="cpoRubricSettings[articleSeparator]"><?php echo _htmlspecialchars($_POST['cpoRubricSettings']['articleSeparator']); ?></textarea>
                <?php echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedsettings-divider'); ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Pager texts:'); ?></td>
            <td class="rightrow">
                <?php echo ___('previous page'); ?><br />
                <input name="cpoRubricSettings[pager_previous]" type="text" value="<?php echo $_POST['cpoRubricSettings']['pager_previous']; ?>" class="text inputwidth">
                <br /><?php echo ___('next page'); ?><br />
                <input name="cpoRubricSettings[pager_next]" type="text" value="<?php echo $_POST['cpoRubricSettings']['pager_next']; ?>" class="text inputwidth">
                <br /><br />
                <?php 
                printf(' <input class="checkbox" type="checkbox" name="cpoRubricSettings[pager_showresults]" value="1" id="pager_showresults" %s>',
                    $_POST['cpoRubricSettings']['pager_showresults'] ? 'checked' : ''
                );
                echo '<label for="pager_showresults">';
                echo ' '.___('show extended information'); 
                echo '</label>';
                echo '<br />'.___('Found:'); 
                ?>
                <br />
                <input name="cpoRubricSettings[pager_found]" type="text" value="<?php echo $_POST['cpoRubricSettings']['pager_found']; ?>" class="text inputwidth">
                <br /><?php echo ___('Results:'); ?><br />
                <input name="cpoRubricSettings[pager_results]" type="text" value="<?php echo $_POST['cpoRubricSettings']['pager_results']; ?>" class="text inputwidth">
                <?php 
                echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedsettings-navigation'); 
                echo '<br /><br /><img src="'.SKIN_URL.'sym_note.gif" style="vertical-align: text-bottom;" alt="'.__('Note').'" title="'.__('Note').'"> '.
                    ___('If a field is empty it will use the caption of the field as default.');
                ?>
            </td>
        </tr><tr>
            <td class="leftrow"><?php echo ___('Enable archive:'); ?></td>
            <td class="rightrow">
                <?php 
                echo '<input name="cpoRubricSettings[showArchive]" class="checkbox" type="checkbox" value="1" id="showArchive" ';
                echo ($_POST['cpoRubricSettings']['showArchive'] ? 'checked' : '').'> ';
                echo '<label for="showArchive">';
                echo ___('show link to archived (expired) messages displaying the following linktext:');
                echo '</label>';
                echo help('rubrics-listrubrics.html#rubrics-rubricsettings-extendedsettings-archive'); 
                echo '<br />';

                echo '<input name="cpoRubricSettings[showArchiveText]" type="text" '
                    .'value="'._htmlspecialchars($_POST['cpoRubricSettings']['showArchiveText']).'" class="text inputwidth">';
                ?>
            </td>
        </tr><tr>
            <td class="leftrow">&nbsp;</td>
            <td class="rightrow">
                <input type="submit" class="button" value="<?php echo ___('save'); ?>">
                <input type="submit" class="button" name="backtolist" value="<?php echo ___('save and go back to rubric list'); ?>">
            </td>
        </tr>
        </tbody></table>
        </form>
        <?php
        require(CPO_BASEDIR.'_include/footer.php');

        break; // }}}
    case 'reallydelete': // {{{
        require(CPO_BASEDIR.'_include/header.php');

        printPageHeader(
            ___('Delete rubric'),
            sprintf(___('You are going to delete the rubric %s.'),
                '<em>'._htmlspecialchars($name).'</em>'
            ),
            'rubrics-listrubrics.html#rubrics-rubricsettings-deleterubric'
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to delete the rubric %s and all containing articles, etc.?'),
            '<em>'._htmlspecialchars($name).'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('rubrics_delete_really');
        $message .= '<input type="hidden" name="id" value="'._htmlspecialchars($_REQUEST['id']).'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, delete').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not delete').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        include(CPO_BASEDIR.'_include/footer.php');

        break;
        // }}}
    }
}