<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id: users.php 109 2006-08-11 22:11:38Z balu $ */
define('CPO', true); 
require_once('../_include/checkaccess.inc.php');

$anzahl = 10; // FIXME system settings?

$actions = array();
if (isset($_REQUEST['action']))
    is_array($_REQUEST['action']) 
        ? $actions = $_REQUEST['action'] 
        : $actions = array($_REQUEST['action']);

while ($nextaction = array_shift($actions)) {
    switch ($nextaction) {
    case 'usergroups_create': // {{{
        $_POST['id'] = 0;
        $_POST['usergroup'] = '';
        $_POST['description'] = '';
        $views = array('edit_form');
        break;
        // }}}
    case 'usergroups_change': // {{{
        $query = 'SELECT usergroup, description '
            .'FROM '.CPO_USERGROUPS.' '
            .'WHERE id='.(int)$_REQUEST['id'];
        $db = new DB;
        $db->query($query);
        $db->next_record();

        $_POST['id'] = $_REQUEST['id'];
        $_POST['usergroup'] = $db->v('usergroup');
        $_POST['description'] = $db->v('description');

        $views = array('edit_form');
        break;
        // }}}
    case 'usergroups_save': // {{{
        $views = array('edit_form');

        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            if (empty($_POST['id'])) { // create
                logaction('create usergroup', 'CSRF check failed.');
            } else {
                logaction('edit usergroup', 'CSRF check failed.');                
            }
            break;
        }

        if (empty($_POST['usergroup'])) {
            $message[] = __('Please enter a group name!');
            break;
        }

        if (empty($_POST['id'])) { // create
            $query = 'SELECT COUNT(*) FROM '.CPO_USERGROUPS.' '
                    ."WHERE usergroup='".addslashes($_POST['usergroup'])."' ";
            $db = new DB;
            $db->query($query);
            $db->next_record();

            if ($db->v('COUNT(*)')>0) { 
                $message[] = __('This group does already exist!');
                break;
            } 

            $query = 'INSERT INTO '.CPO_USERGROUPS.' SET '
                    ."id = '', " // id
                    ."usergroup = '".addslashes($_POST['usergroup'])."', "   // usergroup
                    ."description = '".addslashes($_POST['description'])."', " // description
                    ."c_time = '".date('Y-m-d H:i:s')."', "            // c_time
                    ."changer = '".$_SESSION['SID_login']."'";                 // edit
            $db->query($query);

            logaction('create usergroup', $_POST['usergroup']);
            $message[] = sprintf(___('The group of users %s was successfully created.'), '<em>'._htmlspecialchars($_POST['edit_usergroup']).'</em>');

            $views = array('list');
            break;
        }

        $query = 'SELECT COUNT(*) FROM '.CPO_USERGROUPS.' '
                 ."WHERE usergroup='".addslashes($_POST['usergroup'])."' "
                 .'AND id!='.(int)$_POST['id'];
        $db = new DB;
        $db->query($query);
        $db->next_record();

        if ($db->v('COUNT(*)')>0) { 
            $message[] = __('This group does already exist!');
            break;
        }

        $query = 'UPDATE '.CPO_USERGROUPS.' SET '
                ."usergroup = '".addslashes($_POST['usergroup'])."', "
                ."description = '".addslashes($_POST['description'])."' "
                ."WHERE id=".(int)$_POST['id'];
        $db->query($query);

        logaction('edit usergroup', $_POST['usergroup']);
        $message[] = sprintf(___('The group of users %s was successfully edited.'), '<em>'._htmlspecialchars($_POST['usergroup']).'</em>');

        $views = array('list');
        break;
        // }}}
    case 'usergroups_list': // {{{
        $views = array('list');
        break;
        // }}}
    case 'usergroups_delete': // {{{
        $db = new DB;
        $db->query('SELECT usergroup '
                  .'FROM '.CPO_USERGROUPS.' '
                  .'WHERE id='.(int)addslashes($_GET['id'])
        );
        $db->next_record();
        $usergroup = $db->v('usergroup');
        $views = array('reallydelete');
        break; // }}}
    case 'usergroups_delete_really': // {{{
        if (!$antiCSRF->checkToken()) {
            $message[] = ___('Security check failed. Please try again.');
            logaction('delete usergroup', 'CSRF check failed.');
            break;
        }
        
        $db = new DB;
        $db->query('SELECT usergroup '
                  .'FROM '.CPO_USERGROUPS.' '
                  .'WHERE id='.(int)addslashes($_POST['id'])
        );
        $db->next_record();
        $_ug = $db->v('usergroup');

        if (isset($_POST['no'])) {
            $message[] = sprintf(___('The group of users %s was not deleted.'),
                '<em>'._htmlspecialchars($_ug).'</em>'
            );
            break;
        }

        $query = 'DELETE FROM '.CPO_USERGROUPS.' '
                .'WHERE id='.(int)$_POST['id'];
        $db->query($query);

        $query = 'DELETE FROM '.CPO_RUBRIC_PERMISSION.' '
                .'WHERE usergroups_id='.(int)$_POST['id'];
        $db->query($query);

        $query = 'UPDATE '.CPO_USER.' SET '
                .'usergroups_id = 0 '
                .'WHERE usergroups_id='.(int)$_POST['id'];
        $db->query($query);

        logaction('delete usergroup', $_ug);
        $message[] = sprintf(___('The group of users %s was successfully deleted.'), 
            '<em>'._htmlspecialchars($_ug).'</em>');
        break; // }}}
    }
}

include_once(CPO_BASEDIR.'_include/header.php');

if (!isset($views)) $views = array('list');
while ($nextview = array_shift($views)) {
    switch ($nextview) {
    case 'list': // {{{
        printPageHeader(
            __('Work on groups'),
            __('In this view you can work on groups or delete them.'),
            'users-workongroups.html#users-workongroups'
        );

        // how many users are in each group?
        $membercount = array();
        $query = 'SELECT usergroups_id, count(*) as members FROM '.CPO_USER.' '
                .'WHERE id>=0 '
                .'GROUP BY usergroups_id';
        $db = new DB;
        $db->query($query);
        while ($db->next_record()) {
            $membercount[$db->v('usergroups_id')] = $db->v('members');
        }

        $query = 'SELECT id, usergroup, description '
                .'FROM '.CPO_USERGROUPS.' '
                .'ORDER BY usergroup';
        $db = new DB;
        $db->query($query);

        if ($db->num_rows()<=0) { 
            $message[] = __('No usergroups created yet.').' '
                .sprintf(___('You can %screate a new usergroup%s.'),
                '<a href="'.BASE_REL.'_admin/usergroups.php?action=usergroups_create">',
                '</a>');
            include(CPO_BASEDIR.'_include/message.php');
            include_once(CPO_BASEDIR.'_include/footer.php');
            break;
        }

        include(CPO_BASEDIR.'_include/message.php');

        echo '<table class="ruler" style="width: 100%"><thead>';
        echo '<tr>';
        echo '<th style="width: 40%"><span>'.__('Group').help('users-workongroups.html#users-workongroups-group').'</span></th>';
        echo '<th style="width: 5%"><span>'.__('Manage').help('users-workongroups.html#users-workongroups-manage').'</span></th>';
        echo '<th style="width: 40%"><span>'.__('Description').help('users-workongroups.html#users-workongroups-description').'</span></th>';
        echo '<th style="width: 15%"><span>'.__('Group-members').help('users-workongroups.html#users-workongroups-groupmembers').'</span></th>';
        echo '</tr>';
        echo '</thead><tbody>';

        while($db->next_record()) {
            print('<tr>');
            printf('<td>%s</td>', _htmlspecialchars($db->v('usergroup')));
            print ('<td>');
            printIcon(
                BASE_REL.'_admin/usergroups.php?action=usergroups_change&id='.(int)$db->v('id'),
                SKIN_URL.'pic_edit.gif',
                ___('edit group')
            );
            printIcon(
                BASE_REL.'_admin/usergroups.php?action=usergroups_delete&id='.(int)$db->v('id'),
                SKIN_URL.'pic_del.gif',
                ___('delete group')
            );
            print('</td>');
            printf('<td>%s</td>', _htmlspecialchars($db->v('description')));
            printf('<td>%d</td>', $membercount[$db->v('id')]);
            print('</tr>');
        }
        print('</tbody></table>');
        break; // }}}
    case 'reallydelete': // {{{
        printPageHeader(
            ___('Delete group of users'),
            sprintf(___('In this view you can delete the group of users %s.'),
                '<em>'._htmlspecialchars($usergroup).'</em>'
            ),
            '' // helpme
        );
        include(CPO_BASEDIR.'_include/message.php');

        $message = sprintf(___('Are you sure you want to delete the group of users %s?'),
            '<em>'._htmlspecialchars($usergroup).'</em>'
        );

        $message .= '<br /><br />';
        $message .= '<form method="post" action="'.$_SERVER['PHP_SELF'].'">';
        $message .= $antiCSRF->getInput('usergroups_delete_really');
        $message .= '<input type="hidden" name="id" value="'._htmlspecialchars($_GET['id']).'" />';
        $message .= '<input type="submit" name="yes" value="'.___('Yes, delete').'" />&nbsp;';
        $message .= '<input type="submit" name="no" value="'.___('No, do not delete').'" />';
        $message .= '</form>';
        include(CPO_BASEDIR.'_include/confirmation.php');
        include(CPO_BASEDIR.'_include/footer.php');
        break; // }}}
    case 'edit_form': // {{{
        if (!empty($_POST['id'])) {
            printPageHeader(
                ___('Edit group'),
                sprintf(___('In this view you can edit the settings for the group %s.'), '<em>'._htmlspecialchars($_POST['usergroup']).'</em>'),
                '' // helpme
            );
        } else {
            printPageHeader(
                __('Create group'),
                __('In this view you can create a new group.'),
                'users-creategroup.html#users-creategroup'
            );
        }

        include(CPO_BASEDIR.'_include/message.php');

        echo '<table class="colored" style="width: 100%"><thead>';
        echo '<form method="post" action="'.$_SERVER['PHP_SELF'].'" name="newsentry">';
        $antiCSRF->printInput('usergroups_save');
        echo '<input type="hidden" name="id" value="'.(int)$_POST['id'].'" />';
        echo '<tr>';
        echo '<th colspan="2"><span>'.___('Group').'</span></th>';
        echo '</tr>';
        echo '</thead><tbody>';
        echo '<tr>';
        echo '<td class="leftrow">'.___('Group:').'</td>';
        echo '<td class="rightrow">';
        echo '<input type="text" class="inputwidth" name="usergroup" value="'._htmlspecialchars($_POST['usergroup']).'" size="35" maxlength="25">';
        echo help('users-creategroup.html#users-creategroup-group');
        echo '</td>';
        echo '</tr><tr>';
        echo '<td>'.___('Group description:').'</td>';
        echo '<td>';
        echo '<textarea class="inputwidth" rows="10" name="description">'._htmlspecialchars($_POST['description']).'</textarea>';
        echo help('users-creategroup.html#users-creategroup-groupdescription'); 
        echo '</td>';
        echo '</tr>';
        echo '<tr>';
        echo '<td>&nbsp;</td>';
        echo '<td>';
        echo '<input type="submit" class="button" value="'.___('save').'">';
        echo '</td>';
        echo '</tr>';
        echo '</form>';
        echo '</tbody></table>';
        break; // }}}
    }
}

include_once(CPO_BASEDIR.'_include/footer.php');