<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

global $parameters, $replacement, $content, $key;

if (array_key_exists('file', $parameters)) {
    $replacement = $content[$key]['file'];
    return;
}
if (array_key_exists('alttext', $parameters)) {
    $replacement = $content[$key]['alttext'];
    if (!array_key_exists('_htmlspecialchars', $parameters)
    || in_array(strtolower($parameters['_htmlspecialchars']), array('1', 'true', 'on'))) {
        $replacement = _htmlspecialchars($replacement);
    }
    return;
}
if (array_key_exists('width', $parameters)) {
    $replacement = $content[$key]['width'];
    return;
}
if (array_key_exists('height', $parameters)) {
    $replacement = $content[$key]['height'];
    return;
}
if (array_key_exists('description', $parameters)) {
    $replacement = $content[$key]['description'];
    if (!array_key_exists('_htmlspecialchars', $parameters)
    || in_array(strtolower($parameters['_htmlspecialchars']), array('1', 'true', 'on'))) {
        $replacement = _htmlspecialchars($replacement);
    }
    return;
}
if (array_key_exists('hrsize', $parameters)) {
    $replacement = printHumanReadable($content[$key]['size']);
    return;
}
if (array_key_exists('size', $parameters)) {
    $replacement = $content[$key]['size'];
    return;
}
$replacement = sprintf('<img src="../_data/%s" alt="%s" title="%s" width="%d" height="%d" />', 
    $content[$key]['file'],
    _htmlspecialchars($content[$key]['alttext']),
    _htmlspecialchars($content[$key]['description']),
    $content[$key]['width'],
    $content[$key]['height']
);