<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */

// $navi = getNavigation();
// $activeRubric = $cpoRubric['id'];
function getActiveElements($navi='', $activeRubric=0)
{
    if ($navi=='') $navi = getNavigation();
    if (empty($navi)) return false;

    if ($activeRubric==0) $activeRubric = $GLOBALS['cpoRubric']['id'];

    $naviElements = array();
    $actElements  = array();
    $currLevels   = array();
    foreach ($navi as $k=>$v) {
        $currLevels[$v['level']] = $v['id'];

        $naviElements[$v['id']] = $v; 

        if ($v['rubric']['id']==$activeRubric) {
            $actElements = array_splice($currLevels, 0, $v['level']);
        }
    }
    // add an element at position 0, 
    // so that $actElements[Y] makes Y equal the level
    array_unshift($actElements, 'X'); 

    return $actElements;
}

// $navi = getNavigation();
// $activeRubric = $cpoRubric['id'];
// $levels: how many levels to display
// $parent: which element to start with
// $activeOnly: do not print inactive sublevels
function printNavigation($navi = '', $activeRubric = 0, $levels = 99, $parent = 0, $activeOnly = false, $target = '')
{
    if ($navi=='') $navi = getNavigation();
    if (empty($navi)) return false;

    if ($activeRubric==0) $activeRubric = $GLOBALS['cpoRubric']['id'];

    $actLevels = getActiveElements($navi, $activeRubric);

    $level = 0;
    if ($parent==0) $level = 1; // start with first level

    $ulstart = '<ul>';
    $ulend  = '';
    foreach ($navi as $k=>$v) {
        if ($v['level']<$level) $level = 0;            // printed all childs of active parent => clear $level
        if ($v['id']==$parent) $level = $v['level']+1; // found active parent => save $level
        if ($v['level']!=$level) continue;             // not the active level => continue
        if ($v['rubric']['seclevel']==SECLEVEL_CLOSED) {
            if (empty($_SESSION['SID_user']['id'])) continue;
            $db = new DB;
            $db->query("SELECT COUNT(*) FROM ".CPO_RUBRIC_PERMISSION." "
                      ."WHERE rubric_id='".(int)$v['rubric']['id']."' "
                      ."AND usergroups_id='".(int)$_SESSION['SID_user']['usergroups_id']."'");
            $db->next_record();

            if ($db->v('COUNT(*)')<=0 && $_SESSION['SID_user']['admin']!=ROLE_ADMIN) continue;
        }

        echo $ulstart;
        $ulstart = '';
        $ulend = '</ul>';

        // build link
        $link = $v['navigation']['externalURL'];

        $_target = $target;
        // externalURLTarget can be used to override the setting
        if (!empty($v['navigation']['externalURLTarget']))
            $_target = $v['navigation']['externalURLTarget'];

        if (isset($v['rubric']['directory']) && $GLOBALS['cpoSystem']['PATH_INFO']) {
            $link = BASE_ABS.$v['rubric']['directory'].'/index.php/'.urlencode($v['rubric']['name']);
        }

        if (isset($v['rubric']['directory']) && !$GLOBALS['cpoSystem']['PATH_INFO']) {
            $link = BASE_ABS.$v['rubric']['directory'].'/index.php?rubric='.urlencode($v['rubric']['name']);
        }

        // mark active list elements
        if ($actLevels[$level]==$v['id']) echo '<li class="active">';
        else 				              echo '<li>';

        // print caption 
        if (empty($link)) echo _htmlspecialchars($v['caption']);
        else {
            echo '<a ';
            echo 'href="'._htmlspecialchars($link).'"';
            if ($_target!='') echo ' target="'._htmlspecialchars($_target).'"';
            echo '>'._htmlspecialchars($v['caption']).'</a>';
        }

        if ($activeOnly===true) $activeOnly = 0;

        // RECURSION!
        if (
            ($activeOnly===false || $activeOnly>0 || $actLevels[$level]==$v['id']) && // print only active sublevels
            $levels-1>0 // maximum number of levels to print
        ) { 
            $newActiveOnly = $activeOnly;
            if (!is_bool($activeOnly)) $newActiveOnly = $activeOnly - 1 ;
            printNavigation($navi, $activeRubric, $levels-1, $v['id'], $newActiveOnly, $target); 
        }

        echo '</li>';
    }
    echo $ulend;
}
?>
