<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

// choose a template
$template = $db_template;

// if no template is defined yet, use the Rubric standard one
if ($template=='') {
    $template = $cpoRubricSettings['standard_template'];
}

// or get the first template in the database
if ($template=='') {
    $query = 'SELECT id FROM '.CPO_TEMPLATES.' '
            .'LIMIT 0, 1';
    $db_2 = new DB;
    $db_2->query($query);

    if ($db_2->num_rows()<=0) {
        print('ERROR: No article-templates available?');
        return;
    }

    $db_2->next_record();
    $template = $db_2->v('id');
}

// use a template cache to avoid reloading of the templates all the time
if (!isset($templates_cache)) $templates_cache = array();

if (!array_key_exists($template, $templates_cache))  {
    // template not cached, try to fetch it
    $query = 'SELECT tpl_detail, tpl_first, tpl_javascript '
            .'FROM '.CPO_TEMPLATES.' '
            .'WHERE id='.(int)$template;
    $db_2 = new DB;
    $db_2->query($query);

    if ($db_2->num_rows()<=0) {
        printf('ERROR: No article-template <em>%s</em>found?<br />Unable to parse article...', $template);
        return;
    }

    $db_2->next_record();
    $templates_cache[$template]['tpl_first']      = $db_2->v('tpl_first');
    $templates_cache[$template]['tpl_detail']     = $db_2->v('tpl_detail');
    $templates_cache[$template]['tpl_javascript'] = $db_2->v('tpl_javascript');
}

$field = array(
    'index'  => 'tpl_first',
    'php'    => 'tpl_javascript',
    'js'     => 'tpl_javascript',
    'detail' => 'tpl_detail'
);

$template_datei_full = 
     $templates_cache[$template]['tpl_first']."\n"
    .$templates_cache[$template]['tpl_detail']."\n"
    .$templates_cache[$template]['tpl_javascript'];
$template_datei = $templates_cache[$template][$field[$pagetype]];
$templates_id   = $template;

require(CPO_BASEDIR.'_include/parser.php');

// make absolute links for images and files
$template_datei = str_replace('../_data/', BASE_ABS.'_data/', $template_datei); 

$string = explode("\n", $template_datei);
foreach ($string as $output) {
    if ($output=='') continue;

    if ($pagetype != 'js') {
        print($output);
        continue;
    }

    // if output is for javascript, clean "up"
    $output = preg_replace("/(\015\012)|(\015)|(\012)/", '', $output);
    $output = str_replace("'", "\\'", $output);
    printf("document.write('%s');\n", $output);
}
?>
