<?php // vim: set syntax=css :
header('Content-Type: text/css');
?>
body {
	text-decoration: none;      
	color: #357; 
	font-family: Verdana, Arial, Helvetica, sans-serif; 
	background-color: #fff; 
	margin: 0px; 
}

body, table {/* Why do tables use larger font otherwise? */
	font-size: 11px; 
}

/* default alignment of table cells */
td {vertical-align: top; text-align: left;}

/* no borders on images */
img {border: 0px;}

/* header formatting */
h1, h2, h3, h4, h5, h6 {margin: 0 0 1em 0; padding: 0; font-weight: bold;}
h1                 {font-size: 13px;}
h2, h3, h4, h5, h6 {font-size: 11px;} /* default font size */

/* no margin around forms */
form {margin: 0;}

a {font-weight: bold; text-decoration: none; color: #357;}
a:hover   {text-decoration: underline;} 

/* navigation frame */
a.nav   {font-weight:normal;} /* for links in the backend navigation */
.navigation_body {margin: 1em 1em 1em 0;}

/* Warning and Message boxes */
.warning {margin: 1em 0 2em 0; padding: 10px; border: 1px solid #ffa800; background-color: #ffa800;} 
.message {margin: 1em 0 1em 0; padding: 10px; border: 1px solid #ffa800;} 
.message legend {font-size: 11px; color: #ffa800;}
.confirmation {}

/* header on backend pages */ /* FIXME used elsewhere too - remove there */
.header {margin-bottom: 2em;} 

/* CSS for alternating table rows based on javascript */
/* table headers */
/* old table heads 
table thead th {
	background: #abc; 
	color: #fff;
	font-size: 12px;
	font-weight: bold;
	padding: 0.3em;
	text-align: left;
	white-space: nowrap;
}
*/

table thead th {
	padding: 0 2em 0 0.5em;
	text-align: left;
}
table thead th span {
	padding: 0 0.2em;
	font-size: 11px;
	font-weight: bold;
	position: relative;
	bottom: 0.7em;
	background: #fff;
	white-space: nowrap;
}

/* settings for both types of table */
table.colored tr.colorlight, 
tr strong.colorlight,
table.ruler tr.colorlight {background: #fff; border-top: 0px;}  

table.colored tr.colordark,
table.ruler tr.colordark,
tr strong.colordark,
.darker {background: #e8ebf0; border-top: 0px;}  

table.colored tbody td,
table.ruler tbody td {padding: 0.3em;}

/* width of left and right row of system tables - length of input fields */
.leftrow    {width: 25%;}
.rightrow   {width: 75%;}
.inputwidth {width: 95%;}

/* data tables with ruler */
table.ruler {border-collapse: collapse; border: 1px solid #357; margin-bottom: 3em;} 
table.ruler td {border-left: 1px solid #357; border-right: 1px solid #357;} 
table.ruler th {border-left: 1px solid #357; border-right: 1px solid #357;} 
table.ruler tr {border-top: 1px solid #357;}
table tbody tr.selected,
table.ruler tr.ruled {background: #C9D3DE; border-top: 0px;} 

/* alternating colored tables */
table.colored {border-collapse: collapse; border: 1px solid #357; margin-bottom: 3em;} 
table.colored tr {border-top: 1px solid #357;}

/* FIXME the active article in version view */
table tbody tr.table_system_active {background: #C9D3DE; border-top: 0px;} 

/* form elements */
input.text, select {margin: 2px 0; border: 1px solid #b1c1d0; color: #294867; padding: 0;}
input.checkbox {margin: 1px 0 1px 0;}

fieldset {border: 1px solid #357; padding: 0.5em; margin: 0;}
legend {color: #357; font-size: 12px; font-weight: bold;}
textarea, .iframe, iframe {border: 1px solid #b1c1d0; background-color: #fff;}

/* add help icon on help areas */
.help {cursor: help;}

/* DEBUG hover-effect */
.debug {position: relative; top: 0; left: 0; color: #a00; background-color: #fcc; font-weight: bold;}
.debug span:hover {color: #fcc; background: #a00; border: 0px;}
.debug span span {display: none;}
.debug span:hover span {
	display: block;
	min-width: 250px;
	font-weight: normal;
	position: absolute;
	top: 13px;
	left: 0;
	padding: 0.5em;
	background: #fcc;
	color: #a00;
	border: 1px solid #a00;
	font-size: 10px;
	z-index: 100;
}

/* color of placeholders in template editor */
.placeholder {
	color: #f00;
}

.pic {width: 18px; height: 21px;}

.pager {font-size: 10px; margin-top: -1em;}
.pager .active {color: #ffa800;}
.pager .passive {color: #b1c1d0;}

#titleBody {background: url(frame_title_background.gif) repeat-x;}
#titleLogo {position: absolute; top: 0; right: 0;}
#titleBar1 {height: 60px; position: relative;} /* project, login and date */
#titleBar2 {padding: 8px 110px 8px 25px;}      /* rubric information */
#titleBar2, #titleBar2 a {color: #fff;}        /* dark background in header frame */

#previewSelectorBody {border-bottom: 5px solid #357;}
#previewSelector {}
#previewContent {}