<?php /* _\|/_              vim: set et ts=4 sw=4 sts=4 nowrap fdm=marker:
         (o o)                         
+-----oOO-{_}-OOo--------------------------------------------------------+
| ConPresso - Foolproof Content Management                               |
+------------------------------------------------------------------------+
| Copyright (c) Bartels Schoene GmbH & Co. KG, 48149 Muenster, Germany   |
+------------------------------------------------------------------------+
| This source file is subject to ConPresso license version 2002-11-16    |
| that is bundled with this package in the files LICENSE_EN.TXT or       |
| LICENSE_DE.TXT, and is available through the world-wide-web at         |
|     http://www.conpresso.de/license/LICENSE_EN-2002-11-16.TXT or       |
|     http://www.conpresso.de/license/LICENSE_DE-2002-11-16.TXT          |
|                                                                        |
| If you did not receive a copy of the ConPresso license and are unable  |
| to obtain it through the world-wide-web, please send a note to         |
| <license@conpresso.de> so we can e-mail you a copy immediately.        |
+------------------------------------------------------------------------+
| Authors: ConPresso development and support team <support@conpresso.de> |
+------------------------------------------------------------------------+
  $Id$ */
if (!defined('CPO')) exit;

// are we in "select-Mode"?
$select_lid = 0;
$select_rid = 0;
if (!empty($_SESSION['SID_navigation_select_id'])) {
    $message[] = sprintf(__('Select mode active. You can move or %sundo%s the selection.'), 
	    '<a href="'._htmlspecialchars($_SERVER['PHP_SELF']).'?action[]=navigation_select&amp;id=0">',
	    '</a>'
	);

    $query = 'SELECT l, r '
	    .'FROM '.CPO_NAVTREE.' '
	    ."WHERE id='".addslashes($_SESSION['SID_navigation_select_id'])."'";
    DEBUG(1, $query, __FILE__, __LINE__);
    $db = new DB; 
    $db->query($query);
    $db->next_record();
    $select_lid = $db->v('l');
    $select_rid = $db->v('r');
}

printPageHeader(
    ___('Work on navigation'),
    ___('In this view you can edit the navigation structure of your project.'),
    'rubrics-workonnavigation.html#rubrics-workonnavigation'
);

$navigation = getNavigation();

if (count($navigation)<=0) {
    $db = new DB; 
    // find root element
    $query = 'SELECT id '
	    .'FROM '.CPO_NAVTREE.' '
	    ."WHERE l=1";
    DEBUG(1, $query, __FILE__, __LINE__);
    $db->query($query);
    if ($db->num_rows()>0) {
        $db->next_record();
        $_id = $db->v('id');
    } else {
        // no root element found, create a new one and use this.
        $query = 'INSERT INTO '.CPO_NAVTREE.' '
                .'(l, r, caption) '
                .'VALUES (1, 2, \'root\')';
        $db->query($query);

        $db->query('SELECT last_insert_id()');
        $db->next_record();
        $_id = $db->v('last_insert_id()');
    }
    $message[] = sprintf(__('To start with a navigation, please %screate the first element%s.'),
	sprintf('<a href="%1$s?action[]=navigation_addlevel&amp;id=%2$d">', $_SERVER['PHP_SELF'], $_id),
	'</a>'
    );
    include(CPO_BASEDIR.'_include/message.php');
    return;
}
include(CPO_BASEDIR.'_include/message.php');

print('<table class="ruler" style="width: 100%;"><thead><tr>');
print('<th style="width: 45%;"><span>'.__('Navigation').help('rubrics-workonnavigation.html#rubrics-workonnavigation-navigation').'</span></th>');
print('<th style="width: 10%;"><span>'.__('Manage').help('rubrics-workonnavigation.html#rubrics-workonnavigation-edit').'</span></th>');
print('<th style="width: 45%;"><span>'.__('Rubric/URL').help('rubrics-workonnavigation.html#rubrics-workonnavigation-rubricurl').'</span></th>');
print('</tr></thead><tbody>');

if (!isset($_SESSION['SID_navigation_opened'])) $_SESSION['SID_navigation_opened'] = array();
$skip = 1;
foreach ($navigation as $k=>$v) {
    if ($v['level']>$skip) continue;
    if (!array_key_exists($v['id'], $_SESSION['SID_navigation_opened'])) {
        $skip = $v['level'];
    } else $skip++;

    if ($v['l']>=$select_lid && $v['r']<=$select_rid) {
        printf('<tr class="table_system_active">');
    } else {
        printf('<tr>');
    }

    // Navigation
    print('<td>');
    if ($v['childs']<=0) {
        printf('<img src="'.SKIN_URL.'nav_empty.gif" style="margin-left: %sem;"><strong>%s</strong>', ($v['level']-1)*$GLOBALS['navigationIndentFactor'], _htmlspecialchars($v['caption']));
    } else if (array_key_exists($v['id'], $_SESSION['SID_navigation_opened'])) {
        printf('<a href="%s?action[]=close&amp;id=%d"><img src="%s" style="margin-left: %sem;">%s</a>',
            _htmlspecialchars($_SERVER['PHP_SELF']),
            _htmlspecialchars($v['id']),
            SKIN_URL.'nav_close.gif',
            ($v['level']-1)*$GLOBALS['navigationIndentFactor'],
            _htmlspecialchars($v['caption'])
        );
    } else {
        printf('<a href="%s?action[]=open&amp;id=%d"><img src="%s" style="margin-left: %sem;">%s</a>',
            _htmlspecialchars($_SERVER['PHP_SELF']),
            _htmlspecialchars($v['id']),
            SKIN_URL.'nav_open.gif',
            ($v['level']-1)*$GLOBALS['navigationIndentFactor'],
            _htmlspecialchars($v['caption'])
        );
    }
    print('</td>');

    // Manage
    printf('<td style="white-space: nowrap">');
    printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_edit&id='.$v['id'], 
        SKIN_URL.'pic_edit.gif', 
        __('edit navigation element'), 
        true
    );

    // add operations
    printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_addleft&id='.$v['id'], 
        SKIN_URL.'pic_add_level_before.gif', 
        __('add navigation element above'), 
        true
    );
    printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_addright&id='.$v['id'], 
        SKIN_URL.'pic_add_level_below.gif', 
        __('add navigation element below'), 
        true
    );

    if ($v['childs']>0) {
        printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_addlevel&id='.$v['id'], 
            SKIN_URL.'pic_add_level.gif', 
            __('This navigation element already has a sublevel.'), 
            false
        );
    } else {
        printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_addlevel&id='.$v['id'], 
            SKIN_URL.'pic_add_level.gif', 
            __('add new sublevel'), 
            true
        );
    }

    echo '<img src="'.BASE_REL.'_images/transparent.gif" width="4" height="1" alt="">';

    // select operations
    printf('<a href="%1$s?action[]=navigation_select&amp;id=%2$d&amp;"><img src="%3$s" width="18" height="21" alt="%4$s" title="%4$s"></a>',
        _htmlspecialchars($_SERVER['PHP_SELF']),
        _htmlspecialchars($v['id']),
        SKIN_URL.'pic_select_level.gif',
        ___('select entry and subentries')
    );

    if (empty($_SESSION['SID_navigation_select_id']) || ($v['l']>=$select_lid && $v['r']<=$select_rid)) {
        printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_moveleft&id='.$v['id'], 
            SKIN_URL.'pic_move_level_before.gif', 
            ($v['l']>=$select_lid && $v['r']<=$select_rid) ? __('You can not move into the selection') 
                                                           : __('Please select a navigation element.'), 
            false
        );
        printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_moveright&id='.$v['id'], 
            SKIN_URL.'pic_move_level_below.gif', 
            ($v['l']>=$select_lid && $v['r']<=$select_rid) ? __('You can not move into the selection') 
                                                           : __('Please select a navigation element.'), 
            false
        );

        printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_movelevel&id='.$v['id'], 
            SKIN_URL.'pic_move_level.gif', 
            ($v['l']>=$select_lid && $v['r']<=$select_rid) ? __('You can not move into the selection') 
                                                           : __('Please select a navigation element.'), 
            false
        );
    } else {
        printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_moveleft&id='.$v['id'], 
            SKIN_URL.'pic_move_level_before.gif', 
            __('move selected navigation element above'), 
            true
        );
        printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_moveright&id='.$v['id'], 
            SKIN_URL.'pic_move_level_below.gif', 
            __('move selected navigation element below'), 
            true
        );

        if ($v['childs']>0) {
            printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_movelevel&id='.$v['id'], 
                SKIN_URL.'pic_move_level.gif', 
                __('This navigation element already has a sublevel.'), 
                false
            );
        } else {
            printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_movelevel&id='.$v['id'], 
                SKIN_URL.'pic_move_level.gif', 
                __('move selected navigation element into a new sublevel'), 
                true
            );
        }
    }

    // FIXME - confirmation is mission if the new method is used
    /*
    printIcon($_SERVER['PHP_SELF'].'?action[]=navigation_delete&id='.$v['id'], 
        SKIN_URL.'pic_del.gif', 
        __('delete navigation element'), 
        true
    );
    */
    echo '<img src="'.BASE_REL.'_images/transparent.gif" width="4" height="1" alt="">';

    printIcon($_SERVER['PHP_SELF'].'?action=navigation_delete&id='._htmlspecialchars($v['id']),
        SKIN_URL.'pic_del.gif',
        ___('delete entry')
    );

    printf('</td>');

    // Rubric
    $_t = '';
    if ($v['rubric']['id']>0) $_t = $v['rubric']['name'];
    if (!empty($v['navigation']['externalURL'])) $_t = $v['navigation']['externalURL'];
    printf('<td>%s</td>', _htmlspecialchars($_t));

    printf('</tr>');
}
print('</tbody></table>');
?>
