CREATE TABLE cpo_block ( id int(11) NOT NULL auto_increment, news_nr int(11) NOT NULL default '0', create_date datetime NOT NULL default '0000-00-00 00:00:00', log_login_id int(11) NOT NULL default '0', PRIMARY KEY  (id), KEY log_login_id (log_login_id), KEY create_date (create_date), KEY news_nr (news_nr));
CREATE TABLE cpo_content_files ( id int(11) NOT NULL auto_increment, article_id int(11) NOT NULL default '0', fieldname varchar(255) binary NOT NULL default '', file_id int(11) NOT NULL default '0', PRIMARY KEY  (id), KEY article_id (article_id), KEY file_id (file_id));
CREATE TABLE cpo_content_html ( id int(11) NOT NULL auto_increment, article_id int(11) NOT NULL default '0', fieldname varchar(255) binary NOT NULL default '', html mediumtext NOT NULL, PRIMARY KEY  (id), KEY article_id (article_id));
CREATE TABLE cpo_content_images ( id int(11) NOT NULL auto_increment, article_id int(11) NOT NULL default '0', fieldname varchar(255) binary NOT NULL default '', image_id int(11) NOT NULL default '0', PRIMARY KEY  (id), KEY article_id (article_id), KEY image_id (image_id));
CREATE TABLE cpo_content_text ( id int(11) NOT NULL auto_increment, article_id int(11) NOT NULL default '0', fieldname varchar(255) binary NOT NULL default '', text mediumtext NOT NULL, PRIMARY KEY  (id), KEY article_id (article_id));
CREATE TABLE cpo_content_urls ( id int(11) NOT NULL auto_increment, article_id int(11) NOT NULL default '0', fieldname varchar(255) binary NOT NULL default '', url varchar(255) NOT NULL default '', urltext varchar(255) NOT NULL default '', urltarget varchar(255) NOT NULL default '', PRIMARY KEY  (id), KEY article_id (article_id));
CREATE TABLE cpo_data ( id int(11) NOT NULL auto_increment, beschreibung text NOT NULL, alttext varchar(255) NOT NULL default '', datum datetime NOT NULL default '0000-00-00 00:00:00', type varchar(255) NOT NULL default '', datei varchar(255) NOT NULL default '', format int(11) NOT NULL default '0', user_id int(11) NOT NULL default '0', rubric_id int(11) NOT NULL default '0', c_time datetime NOT NULL default '0000-00-00 00:00:00', changer varchar(255) NOT NULL default '', PRIMARY KEY  (id), KEY rubric_id (rubric_id), KEY format (format), KEY datei (datei));
CREATE TABLE cpo_log ( id int(11) NOT NULL auto_increment, user varchar(50) NOT NULL default '', datum datetime NOT NULL default '0000-00-00 00:00:00', aktion varchar(255) NOT NULL default '', bemerkung varchar(255) NOT NULL default '', PRIMARY KEY  (id));
CREATE TABLE cpo_log_login ( id int(11) NOT NULL auto_increment, user_id int(11) NOT NULL default '0', login datetime NOT NULL default '0000-00-00 00:00:00', last_action datetime NOT NULL default '0000-00-00 00:00:00', ip varchar(255) NOT NULL default '', ip_name varchar(255) NOT NULL default '', browser varchar(255) NOT NULL default '', PRIMARY KEY  (id), KEY user_id (user_id), KEY last_action (last_action));
CREATE TABLE cpo_navtree ( id int(11) NOT NULL auto_increment, l int(11) NOT NULL default '0', r int(11) NOT NULL default '0', caption varchar(255) NOT NULL default '', rubric_id int(11) NOT NULL default '0', settings text NOT NULL, PRIMARY KEY  (id), KEY l (l), KEY r (r), KEY rubric_id (rubric_id));
CREATE TABLE cpo_news ( nr int(11) NOT NULL auto_increment, artikel_archiv int(1) NOT NULL default '0', article_nr int(11) NOT NULL default '0', auth varchar(255) NOT NULL default '', keywords varchar(255) NOT NULL default '', commentary text NOT NULL, rubric_id int(11) NOT NULL default '0', templates_id int(11) NOT NULL default '0', titel varchar(255) NOT NULL default '', datum datetime NOT NULL default '0000-00-00 00:00:00', verfallsdatum datetime NOT NULL default '0000-00-00 00:00:00', pub_datum datetime NOT NULL default '0000-00-00 00:00:00', autor varchar(255) NOT NULL default '', email varchar(255) NOT NULL default '', initial varchar(4) NOT NULL default '', idx varchar(8) NOT NULL default '', freigabe int(1) NOT NULL default '0', released_user_id int(11) NOT NULL default '0', release_date datetime NOT NULL default '0000-00-00 00:00:00', last_modify datetime NOT NULL default '0000-00-00 00:00:00', c_time datetime NOT NULL default '0000-00-00 00:00:00', changer varchar(255) NOT NULL default '', sort_id int(11) NOT NULL default '0', PRIMARY KEY  (nr), KEY cpo_news_archfrei (artikel_archiv,freigabe), KEY cpo_news_datrange (pub_datum,verfallsdatum), KEY cpo_news_category (rubric_id), KEY keywords (keywords));
CREATE TABLE cpo_option ( type varchar(255) NOT NULL default '', options text NOT NULL, id int(11) NOT NULL auto_increment, PRIMARY KEY  (id), KEY type (type));
CREATE TABLE cpo_permission ( id int(11) NOT NULL auto_increment, user_id int(11) NOT NULL default '0', rubric_id int(11) NOT NULL default '0', stufe1 int(1) NOT NULL default '0', stufe2 int(1) NOT NULL default '0', stufe3 int(1) NOT NULL default '0', stufe4 int(1) NOT NULL default '0', PRIMARY KEY  (id), UNIQUE KEY `user_id-rubric_id` (`user_id`,`rubric_id`), KEY rubric_id (rubric_id), KEY user_id (user_id));
CREATE TABLE cpo_placeholders ( id int(11) NOT NULL auto_increment, templates_id int(11) NOT NULL default '0', ttype int(11) NOT NULL default '0', fieldname varchar(255) binary NOT NULL default '', pos int(11) NOT NULL default '0', ddata text NOT NULL, PRIMARY KEY  (id), KEY templates_id (templates_id), KEY pos (pos));
CREATE TABLE cpo_rubric ( id int(11) NOT NULL auto_increment, directory varchar(255) NOT NULL default '', name varchar(255) NOT NULL default '', seclevel int(1) NOT NULL default '0', source_rubric_id int(11) NOT NULL default '0', settings text NOT NULL, PRIMARY KEY  (id), KEY source_rubric_id (source_rubric_id), KEY name (name), KEY directory (directory));
CREATE TABLE cpo_rubric_permission ( id int(11) NOT NULL auto_increment, usergroups_id int(11) NOT NULL default '0', rubric_id int(11) NOT NULL default '0', c_time datetime NOT NULL default '0000-00-00 00:00:00', changer varchar(255) NOT NULL default '', PRIMARY KEY  (id), KEY usergroups_id (usergroups_id));
CREATE TABLE cpo_sessions ( sessid varchar(255) binary NOT NULL default '', lastupdated datetime NOT NULL default '0000-00-00 00:00:00', data text NOT NULL, PRIMARY KEY  (sessid), KEY lastupdated (lastupdated));
CREATE TABLE cpo_snippet ( id int(11) NOT NULL auto_increment, name varchar(255) NOT NULL default '', rubric_id int(11) NOT NULL default '0', user_id int(11) NOT NULL default '0', snippet text NOT NULL, lastmodify datetime NOT NULL default '0000-00-00 00:00:00', c_time datetime NOT NULL default '0000-00-00 00:00:00', changer varchar(255) NOT NULL default '', PRIMARY KEY  (id));
CREATE TABLE cpo_statistics ( id int(11) NOT NULL auto_increment, rubric_id int(11) NOT NULL default '0', index_site int(11) NOT NULL default '0', detail_site int(11) NOT NULL default '0', archive_site int(11) NOT NULL default '0', last_hit datetime NOT NULL default '0000-00-00 00:00:00', c_time datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY  (id));
CREATE TABLE cpo_templates ( id int(11) NOT NULL auto_increment, name varchar(255) NOT NULL default '', tpl_first text NOT NULL, tpl_detail text NOT NULL, tpl_javascript text NOT NULL, c_time datetime NOT NULL default '0000-00-00 00:00:00', changer varchar(255) NOT NULL default '', PRIMARY KEY  (id));
CREATE TABLE cpo_tpl_assignment ( id int(11) NOT NULL auto_increment, rubric_id int(11) NOT NULL default '0', templates_id int(11) NOT NULL default '0', c_time datetime NOT NULL default '0000-00-00 00:00:00', changer varchar(255) NOT NULL default '', PRIMARY KEY  (id));
CREATE TABLE cpo_user ( id int(11) NOT NULL, user varchar(255) NOT NULL default '', email varchar(255) NOT NULL default '', language varchar(255) NOT NULL default '', admin int(1) NOT NULL default '0', editor int(1) NOT NULL default '1', usergroups_id int(11) NOT NULL default '0', passwd varchar(32) NOT NULL default '', name varchar(255) NOT NULL default '', initial varchar(255) NOT NULL default '', c_time datetime NOT NULL default '0000-00-00 00:00:00', changer varchar(255) NOT NULL default '', PRIMARY KEY  (id), KEY usergroups_id (usergroups_id));
CREATE TABLE cpo_usergroups ( id int(11) NOT NULL auto_increment, usergroup varchar(25) NOT NULL default '', description varchar(255) NOT NULL default '', c_time datetime NOT NULL default '0000-00-00 00:00:00', changer varchar(255) NOT NULL default '', PRIMARY KEY  (id), KEY usergroup (usergroup));
CREATE TABLE cpo_modules ( id int(11) NOT NULL auto_increment, name varchar(255) NOT NULL default '', status int(11) NOT NULL default 0, options text NOT NULL, PRIMARY KEY  (id), UNIQUE KEY name (name), KEY status (status))
CREATE TABLE cpo_pagetemplates ( `id` int(10) unsigned NOT NULL auto_increment, `name` varchar(255) NOT NULL default '', `user_id` int(11) NOT NULL default '0', `pagetemplate` text NOT NULL, `saved` datetime NOT NULL default '0000-00-00 00:00:00', PRIMARY KEY  (`id`));
